#ifndef _DEVICE_H
#define _DEVICE_H

FILE *PrepareInputFiles(char DeviceInDir[], char ModelSubDir[],  // in
                  			char DeviceInFileName[], char ModelInDir[]);	// out
FILE *PrepareViewingFiles(char ModelInDir[]);
void CreateVolume(char ModelInDir[], int VolRef,
                  int VolShape, int VolMaterial, int VolBoundaryType,
                  double VolEpsilon, double VolPotential, double VolCharge);
void CreatePolygon(FILE *fMotherInp, FILE *fData, char ModelInDir[],
                    int NbPrimitives,
                    int nvertex,
                    double xvert[], double yvert[], double zvert[],
										double xnorm, double ynorm, double znorm,
                    int VolRef1, int VolRef2, int NbXSegs, int NbZSegs,
										int PeriodicTypeX, int PeriodicInX, double XPeriod,
										int PeriodicTypeY, int PeriodicInY, double YPeriod,
										int PeriodicTypeZ, int PeriodicInZ, double ZPeriod);
void CreateLine(FILE *fMotherInFile, FILE *fData, char ModelInDir[],
                int NbPrimitives,
                int nvertex, double xvert[], double yvert[], double zvert[],
                double radius, int VolRef1, int VolRef2, int NbSegs,
								int PeriodicTypeX, int PeriodicInX, double XPeriod,
								int PeriodicTypeY, int PeriodicInY, double YPeriod,
								int PeriodicTypeZ, int PeriodicInZ, double ZPeriod);
void CreateMapFile(char ModelInDir[],
                    int NbMaps, int *NbBlock,
                    int *NbXMap, int *NbYMap, int *NbZMap,
                    double *MapLX, double *MapLY, double *MapLZ,
                    double *MapXMid, double *MapYMid, double *MapZMid,
                    int NbLines, int *NbSegments,
                    double *XStart, double *YStart, double *ZStart,
                    double *XStop, double *YStop, double *ZStop,
                    int NbPoints,
                    double *XPoint, double *YPoint, double *ZPoint);
void WriteVolRefInFile(char VolRefInFileName[],
                    		int VolShape, int VolMaterial, double VolEpsilon,
												double VolPotential, double VolCharge,
												int VolBoundaryType);
void WriteSurfaceInFile(char SurfaceInFileName[],
                        int nvertex,
                        double xvert[], double yvert[], double zvert[],
                        double xnorm, double ynorm, double znorm,
                        int VolRef1, int VolRef2,
                        int NbXSegs, int NbYSegs,
												int PeriodicTypeX, int PeriodicInX, double XPeriod,
												int PeriodicTypeY, int PeriodicInY, double YPeriod,
												int PeriodicTypeZ, int PeriodicInZ, double ZPeriod);
void WriteWireInFile(char WireInFileName[],
                      int nvertex,
                      double xvert[], double yvert[], double zvert[],
                      double radius,
                      int VolRef1, int VolRef2, int NbSegs,
											int PeriodicTypeX, int PeriodicInX, double XPeriod,
											int PeriodicTypeY, int PeriodicInY, double YPeriod,
											int PeriodicTypeZ, int PeriodicInZ, double ZPeriod);
void WriteMapInFile(char MapInFileName[], // MapFile
                    int NbMaps, int *NbBlock,
                    int *NbXMap, int *NbYMap, int *NbZMap,
                    double *MapLX, double *MapLY, double *MapLZ,
                    double *MapXMid, double *MapYMid, double *MapZMid,
                    int NbLines, int *NbSegments,
                    double *XStart, double *YStart, double *ZStart,
                    double *XStop, double *YStop, double *ZStop,
                    int NbPoints,
                    double *XPoint, double *YPoint, double *ZPoint);
void WriteDeviceDataFile(FILE *fData, int NbPrimitives,
                          int nvertex,
                          double xvert[], double yvert[], double zvert[],
													int PeriodicTypeX, int PeriodicInX, double XPeriod,
													int PeriodicTypeY, int PeriodicInY, double YPeriod,
													int PeriodicTypeZ, int PeriodicInZ, double ZPeriod);
void EndDeviceInputFile(FILE *fMotherInp,
                        int NbBCondns,
                        char OutDir[], char ModelInDir[],
												int NbPrimitives, int NbVolumes);

#endif
