#include <stdio.h>
#include <assert.h>

#include <Interface.h>
#include <Vector.h>
#include <NR.h>
#include <neBEM.h>
#include <Isles.h>



int PostProcess(void)
{
int fstatus;
Point3D point;
double potential;
Vector3D field;

clock_t startPPClock = clock();

point.X = 18.0e-6; point.Y = 3.0e-6; point.Z = 0.0;
// point.X = 0.0; point.Y = 0.0; point.Z = 0.0;
fstatus = neBEMField(&point, &potential, &field);
assert(fstatus == 0);
printf("point.X: %lg, point.Y: %lg, point.Z: %lg\n", point.X, point.Y, point.Z);
printf("Potential: %lg\n", potential);
printf("field.X: %lg, field.Y: %lg, field.Z: %lg\n", field.X, field.Y, field.Z);

point.X = 4.0e-6; point.Y = 9.0e-6; point.Z = 0.0;
// point.X = 0.0; point.Y = 5.0e-2; point.Z = 0.0;
fstatus = neBEMField(&point, &potential, &field);
assert(fstatus == 0);
printf("point.X: %lg, point.Y: %lg, point.Z: %lg\n", point.X, point.Y, point.Z);
printf("Potential: %lg\n", potential);
printf("field.X: %lg, field.Y: %lg, field.Z: %lg\n", field.X, field.Y, field.Z);

point.X = 25.0e-6; point.Y = 16.0e-6; point.Z = 0.0;
// point.X = 0.0; point.Y = -5.0e-2; point.Z = 0.0;
fstatus = neBEMField(&point, &potential, &field);
assert(fstatus == 0);
printf("point.X: %lg, point.Y: %lg, point.Z: %lg\n", point.X, point.Y, point.Z);
printf("Potential: %lg\n", potential);
printf("field.X: %lg, field.Y: %lg, field.Z: %lg\n", field.X, field.Y, field.Z);

point.X = 5.0e-6; point.Y = 17.0e-6; point.Z = 0.0;
// point.X = 5.0e-2; point.Y = 5.0e-2; point.Z = 5.0e-2;
fstatus = neBEMField(&point, &potential, &field);
assert(fstatus == 0);
printf("point.X: %lg, point.Y: %lg, point.Z: %lg\n", point.X, point.Y, point.Z);
printf("Potential: %lg\n", potential);
printf("field.X: %lg, field.Y: %lg, field.Z: %lg\n", field.X, field.Y, field.Z);

clock_t stopPPClock = clock();
neBEMTimeElapsed(startPPClock, stopPPClock);
printf("to post process.\n");

return(0);
}
