#include <stdio.h>
#include <assert.h>

#include <Interface.h>
#include <Vector.h>
#include <NR.h>
#include <neBEM.h>
#include <Isles.h>


// This part is for post-processing and can be as simple and as elaborate
// as the user decides. A typical evaluation of potential and field is
// demonstrated below.

// Finds potential and field for comparison with known numerical solution
int PostProcess(void)
{
int fstatus;
Point3D point;
double potential;
Vector3D field;

point.X = 0.0; point.Y = 0.0; point.Z = 0.0;
fstatus = neBEMField(&point, &potential, &field);
assert(fstatus == 0);
printf("point.X: %lg, point.Y: %lg, point.Z: %lg\n", point.X, point.Y, point.Z);
printf("Potential: %lg\n", potential);
printf("field.X: %lg, field.Y: %lg, field.Z: %lg\n", field.X, field.Y, field.Z);

point.X = 0.0; point.Y = 5.0e-2; point.Z = 0.0;
fstatus = neBEMField(&point, &potential, &field);
assert(fstatus == 0);
printf("point.X: %lg, point.Y: %lg, point.Z: %lg\n", point.X, point.Y, point.Z);
printf("Potential: %lg\n", potential);
printf("field.X: %lg, field.Y: %lg, field.Z: %lg\n", field.X, field.Y, field.Z);

point.X = 0.0; point.Y = -5.0e-2; point.Z = 0.0;
fstatus = neBEMField(&point, &potential, &field);
assert(fstatus == 0);
printf("point.X: %lg, point.Y: %lg, point.Z: %lg\n", point.X, point.Y, point.Z);
printf("Potential: %lg\n", potential);
printf("field.X: %lg, field.Y: %lg, field.Z: %lg\n", field.X, field.Y, field.Z);

point.X = 5.0e-2; point.Y = 5.0e-2; point.Z = 5.0e-2;
fstatus = neBEMField(&point, &potential, &field);
assert(fstatus == 0);
printf("point.X: %lg, point.Y: %lg, point.Z: %lg\n", point.X, point.Y, point.Z);
printf("Potential: %lg\n", potential);
printf("field.X: %lg, field.Y: %lg, field.Z: %lg\n", field.X, field.Y, field.Z);

return 0;
}
